<?php

// ---------------------------------------------------------------------
//            (c) sgs-visual.de 2024 - Öffnungszeiten 1.0
//              Ausgabe Montag bis Sonntag  VORSCHAU
//
//                      https://www.sgs-visual.de
// ---------------------------------------------------------------------


date_default_timezone_set('Europe/Berlin');
  
function oeffnungszeiten() {

 // Wochentage ( Montag = 1, Dienstag = 2, ... Samstag = 6, Sonntag = 7 )
 $close = array(7);

 $tage = ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"]; // Wochentage haben Namen...
 $monate = [1=>"Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"];
 $tag = date("w");

// Montag
 if (date('N') == "1") {
  $time_start = file_get_contents("data/startMo.dat");
  $time_stop = file_get_contents("data/stopMo.dat"); 
 }

// Dienstag
 if (date('N') == "2") {
  $time_start = file_get_contents("data/startDi.dat");
  $time_stop = file_get_contents("data/stopDi.dat"); 
 }

// Mittwoch
 if (date('N') == "3") {
  $time_start = file_get_contents("data/startMi.dat");
  $time_stop = file_get_contents("data/stopMi.dat"); 
 }

 // Donnerstag
 if (date('N') == "4") {
  $time_start = file_get_contents("data/startDo.dat");
  $time_stop = file_get_contents("data/stopDo.dat"); 
 }

 //Freitag
 if (date('N') == "5") {
  $time_start = file_get_contents("data/startFr.dat");
  $time_stop = file_get_contents("data/stopFr.dat");
 }

// Samstag
 if (date('N') == "6") {
  $time_start = file_get_contents("data/startSa.dat");
  $time_stop = file_get_contents("data/stopSa.dat");
 }

// Am Sonntag ist geschlossen
 if (date('N') == "7") {
  $time_start = file_get_contents("data/startSo.dat");
  $time_stop = file_get_contents("data/stopSo.dat");
 }

// Feste und bewegliche Feiertage
$holiday =  [ 
 '01.01',             // Neues Jahr
//        $heute = date("d.m"), // heutiges Datum - zum testen!
 $Rosenmontag = date("d.m",easter_date()-48*86400), // Rosenmontag,  48 Tage vor Ostern
 $Karfreitag = date("d.m",easter_date()-2*86400), // Karfreitag, 2 Tage vor Ostern
 $Ostermontag = date("d.m",easter_date()+86400), // Ostermontag
 '01.05',             // Erster Mai
 $ChristiHimmelfahrt = date("d.m",easter_date()+39*86400),
 $Pfingstmontag = date("d.m",easter_date()+50*86400),
 $Fronleichnam = date("d.m",easter_date()+60*86400),
 '03.10', // Tag der deutschen Einheit
 '01.11',  // Allerheiligen
 '24.12', // Heiliger Abend
 '25.12', // 1 Weihnachtstag
 '26.12', // 2 Weihnachtstag
 '31.12', // Silvester
];

$feiertag ="keiner";


  // Prüfen ob geöffnet ist (Wochentag, Uhrzeit und Feiertag)
  if (date('N') != in_array(date('N'), $close) &&
      date('H:i') >= $time_start &&
      date('H:i') <= $time_stop &&
      date('d.m') != in_array(date('d.m'), $holiday)) {
    $offen = ' Wir haben heute von ' . $time_start . ' bis ' . $time_stop . ' <strong class="offen">geöffnet</strong>';
   }
   else {
     if (date('d.m') == in_array(date('d.m'), $holiday)) {
      if (date("d.m") == "01.01") $feiertag = 'Neujahr';
//    if (date("d.m") == "$heute")  $feiertag = 'Aktuelles Datum'; // heutiges Datum - zum testen!
      if (date("d.m") == "$Rosenmontag") $feiertag = 'Rosenmontag';
      if (date("d.m") == "$Karfreitag") $feiertag = 'Karfreitag';
      if (date("d.m") == "$Ostermontag") $feiertag = 'Ostemontag';
      if (date("d.m") == "01.05") $feiertag = 'Tag der Arbeit';
      if (date("d.m") == "$ChristiHimmelfahrt") $feiertag = 'Christi Himmelfahrt';
      if (date("d.m") == "$Pfingstmontag") $feiertag = 'Pfingstmontag';
      if (date("d.m") == "$Fronleichnam ") $feiertag = 'Fronleichnam';
      if (date("d.m") == "03.10") $feiertag = 'Tag der Deutschen Einheit';
      if (date("d.m") == "01.11") $feiertag = 'Allerheiligen';
      if (date("d.m") == "24.12") $feiertag = 'Heiliger Abend';
      if (date("d.m") == "25.12") $feiertag = '1. Weihnachtstag';
      if (date("d.m") == "26.12") $feiertag = '2. Weihnachtstag';
      if (date("d.m") == "31.12") $feiertag = 'Silvester';
   }

   if ($feiertag != "keiner") {
    $offen = " &#9999; " . $feiertag . ', Heute ist <strong class="geschlossen">geschlossen</strong>.';
   }
//   elseif ($tage[$tag] == "Samstagtag") {
//    $offen = 'Heute haben wir <strong class="geschlossen">geschlossen</strong>.';
//   }
   elseif ($tage[$tag] == "Sonntag") {
    $offen = 'Heute haben wir <strong class="geschlossen">geschlossen</strong>.';
   }
   else {
    $offen = 'Zur Zeit haben wir <strong class="geschlossen">geschlossen</strong>.';
   }
  }

//   $offen = 'Wir machen Urlaub. Wir haben bis zum 14. April 2024 <strong class="geschlossen">geschlossen</strong>'; // Info über Urlaub
  return($offen);
}


// -------------------------------------------------------------------------
// ---- Hier folgt der sichtbare Ausgabeteil der Öffnungszeiten  ---
// -------------------------------------------------------------------------

?>

    <title>Vorschau Mo-So </title>

<?php

// --- Daten laden ---

// Montag

           $startMo = file_get_contents("data/startMo.dat");
           $stopMo = file_get_contents("data/stopMo.dat");

// Dienstag

           $startDi = file_get_contents("data/startDi.dat");
           $stopDi = file_get_contents("data/stopDi.dat");

// Mittwoch

           $startMi = file_get_contents("data/startMi.dat");
           $stopMi = file_get_contents("data/stopMi.dat");

// Donnerstag

           $startDo = file_get_contents("data/startDo.dat");
           $stopDo = file_get_contents("data/stopDo.dat");

// Freitag

           $startFr = file_get_contents("data/startFr.dat");
           $stopFr = file_get_contents("data/stopFr.dat");

// Samstag

           $startSa = file_get_contents("data/startSa.dat");
           $stopSa = file_get_contents("data/stopSa.dat");

// Sonntag

           $startSo = file_get_contents("data/startSo.dat");
           $stopSo = file_get_contents("data/stopSo.dat");


// -------------------------------------------------
// ----- Daten wurden geladen ---------------
// -------------------------------------------------


?>

<html>
  <body>


  <link href="css/style.css" rel="stylesheet" type="text/css">

   <! --- Ausgabe der Öffnungszeiten in einer DIV-Box--->

<center>
       <div class="ErsteBox">

<table class="tg">

<! --- ÖFFNUNGSZEITEN TEXT --->
  <tr>

    <th class="tg-titel" colspan="5">Öffnunszeiten</th>

  </tr>

<! --- MONTAG --->
  <tr>
    <td class="tg-mo"><?php if (date('N') == "1") {echo "<b>Montag:</b>";}else{echo "Montag:";}?></td>
    <td class="tg-mo"><?php echo $startMo; ?></td>
    <td class="tg-mo">Uhr bis&nbsp;</td>
    <td class="tg-mo"><?php echo $stopMo; ?></td>
    <td class="tg-mo">Uhr</td>
  </tr>
<! --- DIENSTAG --->
  <tr>
    <td class="tg-di"><?php if (date('N') == "2") {echo "<b>Dienstag:</b>";}else{echo "Dienstag:";}?></td>
    <td class="tg-di"><?php echo $startDi; ?></td>
    <td class="tg-di">Uhr bis&nbsp;</td>
    <td class="tg-di"><?php echo $stopDi; ?></td>
    <td class="tg-di">Uhr</td>
  </tr>
<! --- MITTWOCH --->
  <tr>
    <td class="tg-mi"><?php if (date('N') == "3") {echo "<b>Mittwoch:</b>";}else{echo "Mittwoch:";}?></td>
    <td class="tg-mi"><?php echo $startMi; ?></td>
    <td class="tg-mi">Uhr bis&nbsp;</td>
    <td class="tg-mi"><?php echo $stopMi; ?></td>
    <td class="tg-mi">Uhr</td>
  </tr>
<! --- DONNERSTAG --->
  <tr>
    <td class="tg-do"><?php if (date('N') == "4") {echo "<b>Donnerstag:</b>";}else{echo "Donnerstag:";}?>&nbsp;</td>
    <td class="tg-do"><?php echo $startDo; ?></td>
    <td class="tg-do">Uhr bis&nbsp;</td>
    <td class="tg-do"><?php echo $stopDo; ?></td>
    <td class="tg-do">Uhr</td>
  </tr>
<! --- FREITAG --->
  <tr>
    <td class="tg-fr"><?php if (date('N') == "5") {echo "<b>Freitag:</b>";}else{echo "Freitag:";}?></td>
    <td class="tg-fr"><?php echo $startFr; ?></td>
    <td class="tg-fr">Uhr bis&nbsp;</td>
    <td class="tg-fr"><?php echo $stopFr; ?></td>
    <td class="tg-fr">Uhr</td>
  </tr>
<! --- SAMSTAG --->
  <tr>
    <td class="tg-sa"><?php if (date('N') == "6") {echo "<b>Samstag:</b>";}else{echo "Samstag:";}?></td>
    <td class="tg-sa"><?php echo $startSa; ?></td>
    <td class="tg-sa">Uhr bis&nbsp;</td>
    <td class="tg-sa"><?php echo $stopSa; ?></td>
    <td class="tg-sa">Uhr</td>
  </tr>
<! --- SONNTAG --->
  <tr>
    <td class="tg-so"><?php if (date('N') == "7") {echo "<b>Sonntag:</b>";}else{echo "Sonntag:";}?></td>
    <td class="tg-so"><?php echo $startSo; ?></td>
    <td class="tg-so">Uhr bis&nbsp;</td>
    <td class="tg-so"><?php echo $stopSo; ?></td>
    <td class="tg-so">Uhr</td>
  </tr>

  
</table>

<!--- Ende der Ausgabe --->



</div>

       <div class="ZweiteBox">

<?php
// --- Ausgabe ob offen oder geschlossen ist -----------

$offen = oeffnungszeiten();
echo $offen;

?>
   </div>
</center>
  </body>
</html>